package org.java.evolutionary.sequence.func;

import ec.EvolutionState;
import ec.Problem;
import org.java.evolutionary.sequence.MotifData;
import ec.gp.ADFStack;
import ec.gp.GPData;
import ec.gp.GPIndividual;
import ec.gp.GPNode;
import ec.util.Parameter;
/**
 * This function or non-terminal is used to do OR/^ connection between two Nodes, can
 * be Compositional, Regional, Correlational etc. This is used for disjunction in combinations
 * @author udaykamath
 *
 */
public class Or extends GPNode {
	public String toString() {
		return " OR ";
	}

	public void checkConstraints(final EvolutionState state, final int tree,
			final GPIndividual typicalIndividual, final Parameter individualBase) {
		super.checkConstraints(state, tree, typicalIndividual, individualBase);
		if (children.length != 2)
			state.output.error("Incorrect number of children for node "
					+ toStringForError() + " at " + individualBase);
	}

	public void eval(final EvolutionState state, final int thread,
			final GPData input, final ADFStack stack,
			final GPIndividual individual, final Problem problem) {
		boolean resultLhs, resultRhs;
		MotifData motifData = ((MotifData) (input));

		children[0].eval(state, thread, input, stack, individual, problem);
		resultLhs = motifData.matches;

		children[1].eval(state, thread, input, stack, individual, problem);
		resultRhs = motifData.matches;
		motifData.matches = (resultLhs || resultRhs);
	}
}
